# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from oceanxbridgeplatformapis.api_helper import APIHelper
from oceanxbridgeplatformapis.models.address import Address
from oceanxbridgeplatformapis.models.asn_product import ASNProduct
from oceanxbridgeplatformapis.models.asn_shipment import ASNShipment
from oceanxbridgeplatformapis.models.option import Option


class ASNUpdateRequest(object):

    """Implementation of the 'ASNUpdateRequest' model.

    TODO: type model description here.

    Attributes:
        asn_created_date (datetime): ASN Created date in source system.
        sub_division (string): TODO: type description here.
        source_revision_number (string): TODO: type description here.
        line_items (list of ASNProduct): TODO: type description here.
        expected_arrival_date (datetime): Date on which the Advance Shipping
            Notice is expected to arrive at the OceanX warehouse.
        shipment (ASNShipment): TODO: type description here.
        ship_from (Address): The address object model definition that is
            used.
        ship_to (Address): The address object model definition that is used.
        recipient_note (string): Can be used to provide instructions to
            recipient on how to process and store received inventory.
        custom_options (list of Option): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "asn_created_date": 'asnCreatedDate',
        "line_items": 'lineItems',
        "ship_from": 'shipFrom',
        "sub_division": 'subDivision',
        "source_revision_number": 'sourceRevisionNumber',
        "expected_arrival_date": 'expectedArrivalDate',
        "shipment": 'shipment',
        "ship_to": 'shipTo',
        "recipient_note": 'recipientNote',
        "custom_options": 'customOptions'
    }

    _optionals = [
        'sub_division',
        'source_revision_number',
        'expected_arrival_date',
        'shipment',
        'ship_to',
        'recipient_note',
        'custom_options',
    ]

    def __init__(self,
                 asn_created_date=None,
                 line_items=None,
                 ship_from=None,
                 sub_division=APIHelper.SKIP,
                 source_revision_number=APIHelper.SKIP,
                 expected_arrival_date=APIHelper.SKIP,
                 shipment=APIHelper.SKIP,
                 ship_to=APIHelper.SKIP,
                 recipient_note=APIHelper.SKIP,
                 custom_options=APIHelper.SKIP):
        """Constructor for the ASNUpdateRequest class"""

        # Initialize members of the class
        self.asn_created_date = APIHelper.RFC3339DateTime(asn_created_date) if asn_created_date else None 
        if sub_division is not APIHelper.SKIP:
            self.sub_division = sub_division 
        if source_revision_number is not APIHelper.SKIP:
            self.source_revision_number = source_revision_number 
        self.line_items = line_items 
        if expected_arrival_date is not APIHelper.SKIP:
            self.expected_arrival_date = APIHelper.RFC3339DateTime(expected_arrival_date) if expected_arrival_date else None 
        if shipment is not APIHelper.SKIP:
            self.shipment = shipment 
        self.ship_from = ship_from 
        if ship_to is not APIHelper.SKIP:
            self.ship_to = ship_to 
        if recipient_note is not APIHelper.SKIP:
            self.recipient_note = recipient_note 
        if custom_options is not APIHelper.SKIP:
            self.custom_options = custom_options 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        asn_created_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("asnCreatedDate")).datetime if dictionary.get("asnCreatedDate") else None
        line_items = None
        if dictionary.get('lineItems') is not None:
            line_items = [ASNProduct.from_dictionary(x) for x in dictionary.get('lineItems')]
        ship_from = Address.from_dictionary(dictionary.get('shipFrom')) if dictionary.get('shipFrom') else None
        sub_division = dictionary.get("subDivision") if dictionary.get("subDivision") else APIHelper.SKIP
        source_revision_number = dictionary.get("sourceRevisionNumber") if dictionary.get("sourceRevisionNumber") else APIHelper.SKIP
        expected_arrival_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("expectedArrivalDate")).datetime if dictionary.get("expectedArrivalDate") else APIHelper.SKIP
        shipment = ASNShipment.from_dictionary(dictionary.get('shipment')) if 'shipment' in dictionary.keys() else APIHelper.SKIP
        ship_to = Address.from_dictionary(dictionary.get('shipTo')) if 'shipTo' in dictionary.keys() else APIHelper.SKIP
        recipient_note = dictionary.get("recipientNote") if dictionary.get("recipientNote") else APIHelper.SKIP
        custom_options = None
        if dictionary.get('customOptions') is not None:
            custom_options = [Option.from_dictionary(x) for x in dictionary.get('customOptions')]
        else:
            custom_options = APIHelper.SKIP
        # Return an object of this model
        return cls(asn_created_date,
                   line_items,
                   ship_from,
                   sub_division,
                   source_revision_number,
                   expected_arrival_date,
                   shipment,
                   ship_to,
                   recipient_note,
                   custom_options)
