# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from oceanxbridgeplatformapis.api_helper import APIHelper
from oceanxbridgeplatformapis.models.pagination import Pagination
from oceanxbridgeplatformapis.models.returns import Returns


class ReturnListDetails(object):

    """Implementation of the 'returnListDetails' model.

    TODO: type model description here.

    Attributes:
        start_date (date): The begin date in a range to return event results
            by. Use the following format -> YYYY-MM-DD. Most recent records
            are returned if date range is NOT specified. Retrieves results for
            specified date range a default 20 records of returns data with
            pagination. Using created_date. Used in conjuction with endDate.
        end_date (date): The end date in a range to return event results by.
            Use the following format -> YYYY-MM-DD. Most recent records are
            returned if date range is NOT specified. Retrieves results for
            specified date range a default 20 records of returns data with
            pagination. Using created_date. Used in conjuction with endDate.
        returns (list of Returns): TODO: type description here.
        pagination (Pagination): Pagination is the sequence of numbers
            assigned to the data request of the API. This is used to help
            managed the viewing of large data sets via API calls.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "returns": 'returns',
        "pagination": 'pagination',
        "start_date": 'startDate',
        "end_date": 'endDate'
    }

    _optionals = [
        'start_date',
        'end_date',
    ]

    def __init__(self,
                 returns=None,
                 pagination=None,
                 start_date=APIHelper.SKIP,
                 end_date=APIHelper.SKIP):
        """Constructor for the ReturnListDetails class"""

        # Initialize members of the class
        if start_date is not APIHelper.SKIP:
            self.start_date = start_date 
        if end_date is not APIHelper.SKIP:
            self.end_date = end_date 
        self.returns = returns 
        self.pagination = pagination 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        returns = None
        if dictionary.get('returns') is not None:
            returns = [Returns.from_dictionary(x) for x in dictionary.get('returns')]
        pagination = Pagination.from_dictionary(dictionary.get('pagination')) if dictionary.get('pagination') else None
        start_date = dateutil.parser.parse(dictionary.get('startDate')).date() if dictionary.get('startDate') else APIHelper.SKIP
        end_date = dateutil.parser.parse(dictionary.get('endDate')).date() if dictionary.get('endDate') else APIHelper.SKIP
        # Return an object of this model
        return cls(returns,
                   pagination,
                   start_date,
                   end_date)
