# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from oceanxbridgeplatformapis.api_helper import APIHelper
from oceanxbridgeplatformapis.models.returned_product_code import ReturnedProductCode


class Returns(object):

    """Implementation of the 'returns' model.

    Shipment return related details such as OMS Order number, return status
    and additional details can be found in the return Model description.

    Attributes:
        order_number (string): The Order Management's unique Order
            identification that was supplied during fulfillment and is
            associated with the return.
        shipment_number (string): The Order Management's unique shipment
            identification that was supplied during fulfillment and is
            associated with the return. Only populate if available for
            orderNumber.
        rma_number (string): Return Merchandise Authorization Number
            associated with a return of a shipment. Return Merchandise
            Authorization Number. Only populate if fulfillment system supplied
            RMA label.
        ship_date (datetime): The time stamp when the shipment was processed
            in WMS. Date-Time in UTC ISO 8601 format. Retrieved from SQL query
            joined w/ return and shipment tables.
        return_date (datetime): The time stamp when the return was processed
            in WMS. Date-Time in UTC ISO 8601 format.
        partial_return (bool): Used to indicate if the shipment was returned
            partially (i.e. not all products were returned). Only return if
            there is a partial return.
        returned_warehouse (WarehousesEnum): Description:    List of available
            warehouses within the OceanX platform. > Warehouses Codes:   *
            `ANC` - Arden, North Carolina   * `COH` - Columbus, Ohio   * `CO2`
            - Columbus SL, OH   * `FHR` - Foothill Ranch, CA > Note: All
            available warehouse codes may not be available for all clients or
            brands.
        products (list of ReturnedProductCode): The list of all products that
            have been returned to the warehouse. Additional details can be
            found in the productCode Model description.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "order_number": 'orderNumber',
        "ship_date": 'shipDate',
        "return_date": 'returnDate',
        "returned_warehouse": 'returnedWarehouse',
        "products": 'products',
        "shipment_number": 'shipmentNumber',
        "rma_number": 'rmaNumber',
        "partial_return": 'partialReturn'
    }

    _optionals = [
        'shipment_number',
        'rma_number',
        'partial_return',
    ]

    def __init__(self,
                 order_number=None,
                 ship_date=None,
                 return_date=None,
                 returned_warehouse=None,
                 products=None,
                 shipment_number=APIHelper.SKIP,
                 rma_number=APIHelper.SKIP,
                 partial_return=False):
        """Constructor for the Returns class"""

        # Initialize members of the class
        self.order_number = order_number 
        if shipment_number is not APIHelper.SKIP:
            self.shipment_number = shipment_number 
        if rma_number is not APIHelper.SKIP:
            self.rma_number = rma_number 
        self.ship_date = APIHelper.RFC3339DateTime(ship_date) if ship_date else None 
        self.return_date = APIHelper.RFC3339DateTime(return_date) if return_date else None 
        self.partial_return = partial_return 
        self.returned_warehouse = returned_warehouse 
        self.products = products 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        order_number = dictionary.get("orderNumber") if dictionary.get("orderNumber") else None
        ship_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("shipDate")).datetime if dictionary.get("shipDate") else None
        return_date = APIHelper.RFC3339DateTime.from_value(dictionary.get("returnDate")).datetime if dictionary.get("returnDate") else None
        returned_warehouse = dictionary.get("returnedWarehouse") if dictionary.get("returnedWarehouse") else None
        products = None
        if dictionary.get('products') is not None:
            products = [ReturnedProductCode.from_dictionary(x) for x in dictionary.get('products')]
        shipment_number = dictionary.get("shipmentNumber") if dictionary.get("shipmentNumber") else APIHelper.SKIP
        rma_number = dictionary.get("rmaNumber") if dictionary.get("rmaNumber") else APIHelper.SKIP
        partial_return = dictionary.get("partialReturn") if dictionary.get("partialReturn") else False
        # Return an object of this model
        return cls(order_number,
                   ship_date,
                   return_date,
                   returned_warehouse,
                   products,
                   shipment_number,
                   rma_number,
                   partial_return)
