# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from oceanxbridgeplatformapis.api_helper import APIHelper
from oceanxbridgeplatformapis.models.product_option import ProductOption
from oceanxbridgeplatformapis.models.shipment_component import ShipmentComponent


class ShipmentProduct(object):

    """Implementation of the 'shipmentProduct' model.

    TODO: type model description here.

    Attributes:
        product_code (string): TODO: type description here.
        product_name (string): TODO: type description here.
        qty (int): TODO: type description here.
        unit_price (float): TODO: type description here.
        unit_sales_tax (float): TODO: type description here.
        unit_sh (float): TODO: type description here.
        unit_total_price (float): TODO: type description here.
        oms_line_number (string): TODO: type description here.
        not_shippable (bool): Used to indicate if the product code will be
            physically shipped out to the customer. Note - If this flag is
            already setup within the OceanX Bridge Platfrom in the Product
            master, the flag sent in the this Shipment request will overright
            that configuration.
        print_invoice (bool): Use to indicate if the product code should be
            printed on the customer facing invoice notice. Note - If this flag
            is already setup within the OceanX Bridge Platfrom in the Product
            master, the flag sent in the this Shipment request will overright
            that configuration.
        post_ship_confirm_line (bool): Use to indicate whether this product
            code will be reported back to the client's system when shipment
            confirmations are posted back. Note - If this flag is already
            setup within the OceanX Bridge Platfrom in the Product master, the
            flag sent in the this Shipment request will overright that
            configuration.
        product_options (list of ProductOption): TODO: type description here.
        components (list of ShipmentComponent): Used to pass the component
            details that make up the product code. Components will only be
            sent when the parent product code is configured as a product type
            of KIT. If parent product code is not configured as a product type
            of KIT, the components will be ignored in this request.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "product_code": 'productCode',
        "qty": 'qty',
        "product_name": 'productName',
        "unit_price": 'unitPrice',
        "unit_sales_tax": 'unitSalesTax',
        "unit_sh": 'unitSH',
        "unit_total_price": 'unitTotalPrice',
        "oms_line_number": 'omsLineNumber',
        "not_shippable": 'notShippable',
        "print_invoice": 'printInvoice',
        "post_ship_confirm_line": 'postShipConfirmLine',
        "product_options": 'productOptions',
        "components": 'components'
    }

    _optionals = [
        'product_name',
        'unit_price',
        'unit_sales_tax',
        'unit_sh',
        'unit_total_price',
        'oms_line_number',
        'not_shippable',
        'print_invoice',
        'post_ship_confirm_line',
        'product_options',
        'components',
    ]

    def __init__(self,
                 product_code=None,
                 qty=None,
                 product_name=APIHelper.SKIP,
                 unit_price=APIHelper.SKIP,
                 unit_sales_tax=APIHelper.SKIP,
                 unit_sh=APIHelper.SKIP,
                 unit_total_price=APIHelper.SKIP,
                 oms_line_number=APIHelper.SKIP,
                 not_shippable=APIHelper.SKIP,
                 print_invoice=APIHelper.SKIP,
                 post_ship_confirm_line=APIHelper.SKIP,
                 product_options=APIHelper.SKIP,
                 components=APIHelper.SKIP):
        """Constructor for the ShipmentProduct class"""

        # Initialize members of the class
        self.product_code = product_code 
        if product_name is not APIHelper.SKIP:
            self.product_name = product_name 
        self.qty = qty 
        if unit_price is not APIHelper.SKIP:
            self.unit_price = unit_price 
        if unit_sales_tax is not APIHelper.SKIP:
            self.unit_sales_tax = unit_sales_tax 
        if unit_sh is not APIHelper.SKIP:
            self.unit_sh = unit_sh 
        if unit_total_price is not APIHelper.SKIP:
            self.unit_total_price = unit_total_price 
        if oms_line_number is not APIHelper.SKIP:
            self.oms_line_number = oms_line_number 
        if not_shippable is not APIHelper.SKIP:
            self.not_shippable = not_shippable 
        if print_invoice is not APIHelper.SKIP:
            self.print_invoice = print_invoice 
        if post_ship_confirm_line is not APIHelper.SKIP:
            self.post_ship_confirm_line = post_ship_confirm_line 
        if product_options is not APIHelper.SKIP:
            self.product_options = product_options 
        if components is not APIHelper.SKIP:
            self.components = components 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        product_code = dictionary.get("productCode") if dictionary.get("productCode") else None
        qty = dictionary.get("qty") if dictionary.get("qty") else None
        product_name = dictionary.get("productName") if dictionary.get("productName") else APIHelper.SKIP
        unit_price = dictionary.get("unitPrice") if dictionary.get("unitPrice") else APIHelper.SKIP
        unit_sales_tax = dictionary.get("unitSalesTax") if dictionary.get("unitSalesTax") else APIHelper.SKIP
        unit_sh = dictionary.get("unitSH") if dictionary.get("unitSH") else APIHelper.SKIP
        unit_total_price = dictionary.get("unitTotalPrice") if dictionary.get("unitTotalPrice") else APIHelper.SKIP
        oms_line_number = dictionary.get("omsLineNumber") if dictionary.get("omsLineNumber") else APIHelper.SKIP
        not_shippable = dictionary.get("notShippable") if "notShippable" in dictionary.keys() else APIHelper.SKIP
        print_invoice = dictionary.get("printInvoice") if "printInvoice" in dictionary.keys() else APIHelper.SKIP
        post_ship_confirm_line = dictionary.get("postShipConfirmLine") if "postShipConfirmLine" in dictionary.keys() else APIHelper.SKIP
        product_options = None
        if dictionary.get('productOptions') is not None:
            product_options = [ProductOption.from_dictionary(x) for x in dictionary.get('productOptions')]
        else:
            product_options = APIHelper.SKIP
        components = None
        if dictionary.get('components') is not None:
            components = [ShipmentComponent.from_dictionary(x) for x in dictionary.get('components')]
        else:
            components = APIHelper.SKIP
        # Return an object of this model
        return cls(product_code,
                   qty,
                   product_name,
                   unit_price,
                   unit_sales_tax,
                   unit_sh,
                   unit_total_price,
                   oms_line_number,
                   not_shippable,
                   print_invoice,
                   post_ship_confirm_line,
                   product_options,
                   components)
