# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from oceanxbridgeplatformapis.api_helper import APIHelper


class Shipping(object):

    """Implementation of the 'Shipping' model.

    Shipping object model definition. Used to pass requested shipping service
    and requested warehouse to be shipped from.

    Attributes:
        ship_service (string): The shipping services that can be used for
            shipments based on delivery times. Usable options; STANDARD (5-7
            days),OVERNIGHT (1-2 days),TWODAY (2 Days),THREEDAY (3 Days)
        requested_warehouse (WarehousesEnum): Description:    List of
            available warehouses within the OceanX platform. > Warehouses
            Codes:   * `ANC` - Arden, North Carolina   * `COH` - Columbus,
            Ohio   * `CO2` - Columbus SL, OH   * `FHR` - Foothill Ranch, CA >
            Note: All available warehouse codes may not be available for all
            clients or brands.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "ship_service": 'shipService',
        "requested_warehouse": 'requestedWarehouse'
    }

    _optionals = [
        'requested_warehouse',
    ]

    def __init__(self,
                 ship_service=None,
                 requested_warehouse=APIHelper.SKIP):
        """Constructor for the Shipping class"""

        # Initialize members of the class
        self.ship_service = ship_service 
        if requested_warehouse is not APIHelper.SKIP:
            self.requested_warehouse = requested_warehouse 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        ship_service = dictionary.get("shipService") if dictionary.get("shipService") else None
        requested_warehouse = dictionary.get("requestedWarehouse") if dictionary.get("requestedWarehouse") else APIHelper.SKIP
        # Return an object of this model
        return cls(ship_service,
                   requested_warehouse)
