# -*- coding: utf-8 -*-

"""
oceanxbridgeplatformapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from apimatic_core.configurations.global_configuration import GlobalConfiguration
from apimatic_core.decorators.lazy_property import LazyProperty
from oceanxbridgeplatformapis.configuration import Configuration
from oceanxbridgeplatformapis.controllers.base_controller import BaseController
from oceanxbridgeplatformapis.configuration import Environment
from oceanxbridgeplatformapis.http.auth.o_auth_2 import OAuth2
from oceanxbridgeplatformapis.controllers.shipments_controller\
    import ShipmentsController
from oceanxbridgeplatformapis.controllers.inventory_controller\
    import InventoryController
from oceanxbridgeplatformapis.controllers.products_controller\
    import ProductsController
from oceanxbridgeplatformapis.controllers.webhooks_controller\
    import WebhooksController


class OceanxbridgeplatformapisClient(object):

    @LazyProperty
    def shipments(self):
        return ShipmentsController(self.global_configuration)

    @LazyProperty
    def inventory(self):
        return InventoryController(self.global_configuration)

    @LazyProperty
    def products(self):
        return ProductsController(self.global_configuration)

    @LazyProperty
    def webhooks(self):
        return WebhooksController(self.global_configuration)

    def __init__(self, http_client_instance=None,
                 override_http_client_configuration=False, http_call_back=None,
                 timeout=60, max_retries=0, backoff_factor=2,
                 retry_statuses=[408, 413, 429, 500, 502, 503, 504, 521, 522, 524],
                 retry_methods=['GET', 'PUT'], environment=Environment.STAGING,
                 access_token='', brand_id='TS', config=None):
        if config is None:
            self.config = Configuration(
                                         http_client_instance=http_client_instance,
                                         override_http_client_configuration=override_http_client_configuration,
                                         http_call_back=http_call_back,
                                         timeout=timeout,
                                         max_retries=max_retries,
                                         backoff_factor=backoff_factor,
                                         retry_statuses=retry_statuses,
                                         retry_methods=retry_methods,
                                         environment=environment,
                                         access_token=access_token,
                                         brand_id=brand_id)
        else:
            self.config = config

        self.global_configuration = GlobalConfiguration(self.config)\
            .global_errors(BaseController.global_errors())\
            .base_uri_executor(self.config.get_base_uri)\
            .user_agent(BaseController.user_agent(), BaseController.user_agent_parameters())\
            .global_header('BrandId', self.config.brand_id)

        self.initialize_auth_managers(self.global_configuration)

        self.global_configuration = self.global_configuration.auth_managers(self.auth_managers)

    def initialize_auth_managers(self, global_config):
        http_client_config = global_config.get_http_client_configuration()
        self.auth_managers = { key: None for key in ['global']}
        self.auth_managers['global'] = OAuth2(http_client_config.access_token)
        return self.auth_managers
